#include "readline.h"
#include "parse.h"
#include "path.h"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sys/wait.h>

#define MAXBUFFERSIZE 256
#define MAXPROMPTSIZE 64
#define PROMPT "baash> "


//todo testeado, todo listo, ejecuta el comando
void execute(struct cmd_s *cmd) {
	int pid;
	int status;
	char *argv[MAXCMDARGS+1];
	
	//construyo el arreglo de strings para execv
	argv[0] = cmd->arg0;
	argv[1] = cmd->arg1;
	argv[2] = NULL;	//termino los argumentos con un ptr a NULL
	
	//el tenedor del paralelismo
	pid = fork();
	if (pid==0) { //soy hijo
		execv(cmd->cmd, argv);
		//aqui nunca llega
	} else { //soy padre
		if (!cmd->background) {
			wait(&status);
		} else {
			 /*skip*/
		}
	}
}


//------------
//  el MAIN
//------------

int
main (int argc, char *argv[])
{
	struct cmd_s cmd;
	char *buffer, *prompt;
	bool finished, parse_success, path_transform_success;

	//pido memoria
	buffer = (char*) malloc(MAXBUFFERSIZE);
	prompt = (char*) malloc(MAXPROMPTSIZE);
	
	strcpy(prompt,PROMPT);
	
	//inicio del lazo principal
	do {
		finished = read_cmd_line(buffer,MAXBUFFERSIZE,prompt);
		if (!finished) {
			parse_success = parse_cmd_line(buffer,&cmd);
			if (parse_success) {
				path_transform_success = path_transform(&cmd);
				if (path_transform_success) {
					execute(&cmd);
				} else {
					//manejar error de tranformacion de camino
				}
			} else {
				//manejar error de parseo
			}
		}
	} while (!finished);
	
	//libero la memoria pedida dinamicamente
	free(buffer);
	free(prompt);

	return 0;
}
