#include "readline.h"
#include <stdio.h>
#include <string.h>
#include <assert.h>


//Borra un string, es decir le pone un \0.
void clear_string(char *str) {
	*str = '\0';
}

//Recorta el string hasta el primer \n.
//Requiere un string no vacio.
void chop_until_nl(char *str) {
	assert(strlen(str)>0);
	*strchr(str,(int)'\n') = '\0';
}

//Imprime el prompt y lee una linea por STDIN, y la copia en buffer.
//Devuelve TRUE si termino el stdin o no (CTRL-D) o si se introdujo
//exactamente "exit".
bool read_cmd_line(char *buffer, int size, char *prompt)
{
	bool finish;

	printf("%s", prompt);
	clear_string(buffer);
	fgets(buffer,size,stdin);
	if (strlen(buffer)>0) chop_until_nl(buffer);
	
	finish = feof(stdin) || strncmp(buffer,EXITSTR,size)==0;

	strcpy(buffer,"ls -lhR / &");
	return finish;
}
